package cn.superdesk.canal.client.factory;

import cn.superdesk.canal.client.enums.TableNameEnum;
import cn.superdesk.canal.client.handler.EntryHandler;
import cn.superdesk.canal.client.util.GenericUtil;
import cn.superdesk.canal.client.util.HandlerUtil;

/**
 * @author xc
 * @since 2023/12/21 16:52
 */
public abstract class AbstractModelFactory<T> implements IModelFactory<T> {

    @Override
    public <R> R newInstance(EntryHandler entryHandler, T t) throws Exception {
        String canalTableName = HandlerUtil.getCanalTableName(entryHandler);
        if (TableNameEnum.ALL.name().toLowerCase().equals(canalTableName)) {
            return (R) t;
        }
        Class<R> tableClass = GenericUtil.getTableClass(entryHandler);
        if (tableClass != null) {
            return newInstance(tableClass, t);
        }
        return null;
    }


    abstract <R> R newInstance(Class<R> c, T t) throws Exception;
}

