package cn.superdesk.canal.client.factory;

import cn.superdesk.canal.client.util.EntryUtil;
import cn.superdesk.canal.client.util.FieldUtil;
import org.apache.commons.lang3.StringUtils;

import java.util.Map;

/**
 * @author xc
 * @since 2023/12/21 16:52
 */
public class MapColumnModelFactory extends AbstractModelFactory<Map<String, String>> {


    @Override
    <R> R newInstance(Class<R> c, Map<String, String> valueMap) throws Exception {
        R                   object      = c.newInstance();
        Map<String, String> columnNames = EntryUtil.getFieldName(object.getClass());
        for (Map.Entry<String, String> entry : valueMap.entrySet()) {
            String fieldName = columnNames.get(entry.getKey());
            if (StringUtils.isNotEmpty(fieldName)) {
                FieldUtil.setFieldValue(object, fieldName, entry.getValue());
            }
        }
        return object;
    }
}